<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 135 $)
*/

namespace extension\ka_extensions\ka_multivendor;

class ControllerCatalogAttributeGroup extends \ControllerCatalogAttributeGroup {

	public function autocomplete() {
		$json = array();

		$this->load->model('catalog/attribute_group');
		
		if (isset($this->request->get['filter_name'])) {

			$filter_data = array(
				'filter_name' => $this->request->get['filter_name'],
				'start'       => 0,
				'limit'       => 5
			);

			$results = $this->model_catalog_attribute_group->getAttributeGroups($filter_data);

			foreach ($results as $result) {
				$json[] = array(
					'attribute_group_id'    => $result['attribute_group_id'],
					'name'            => strip_tags(html_entity_decode($result['name'], ENT_QUOTES, 'UTF-8')),
				);
			}
		}

		$sort_order = array();

		foreach ($json as $key => $value) {
			$sort_order[$key] = $value['name'];
		}

		array_multisort($sort_order, SORT_ASC, $json);

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
}