<?php
/*
	$Project$
	$Author$

	$Version$ ($Revision$)
*/

namespace extension\ka_extensions\ka_multivendor;

class ControllerCatalogCategory extends \ControllerCatalogCategory {

	use \extension\ka_extensions\TraitController;

	protected function getForm() {
	
		$this->disableRender();
		parent::getForm();
		$this->enableRender();
		
		$template = $this->getRenderTemplate();
		$data = $this->getRenderData();

		$this->processCategoryAttributes($data);

		$data['is_ka_multivendor_installed'] = true;
		
		$this->response->setOutput($this->load->view($template, $data));
	}
	
	
	protected function processCategoryAttributes(&$data) {
		$this->load->language('extension/ka_extensions/ka_multivendor/category');
		$this->load->model('catalog/attribute_group');

		if (isset($this->request->post['category_attribute_groups'])) {
			$attribute_groups = $this->request->post['category_attribute_groups'];
		} elseif (isset($this->request->get['category_id'])) {
			$attribute_groups = $this->model_catalog_category->getCategoryAttributeGroups($this->request->get['category_id']);
		} else {
			$attribute_groups = array();
		}

		$data['category_attribute_groups'] = array();

		foreach ($attribute_groups as $attribute_group_id) {
			$attribute_group_info = $this->model_catalog_attribute_group->getAttributeGroup($attribute_group_id);

			if ($attribute_group_info) {
				$data['category_attribute_groups'][] = array(
					'attribute_group_id' => $attribute_group_info['attribute_group_id'],
					'name'               => $attribute_group_info['name']
				);
			}
		}
	}	 
}