<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 98 $)
*/

namespace extension\ka_extensions\ka_multivendor;

class ControllerVendor extends \extension\ka_extensions\Controller {

	public function autocomplete() {
		$json = array();

		if (isset($this->request->get['filter_name'])) {

			$filter_data = array(
				'filter_name' => $this->request->get['filter_name'],
				'start'       => 0,
				'limit'       => 5
			);

			$results = $this->kamodel_vendor->getVendors($filter_data);

			foreach ($results as $result) {
			
				$name = $result['firstname'] . ' ' . $result['lastname'];
			
				$json[] = array(
					'vendor_id' => $result['customer_id'],
					'name'            => strip_tags(html_entity_decode($name, ENT_QUOTES, 'UTF-8'))
				);
			}
		}

		$sort_order = array();

		foreach ($json as $key => $value) {
			$sort_order[$key] = $value['name'];
		}

		array_multisort($sort_order, SORT_ASC, $json);

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
}

class_alias(__NAMESPACE__ . '\ControllerVendor', 'ControllerExtensionKaExtensionsKaMultivendorVendor');