<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 110 $)
*/

namespace extension\ka_extensions\ka_multivendor;

class ModelCustomerCustomer extends \ModelCustomerCustomer {

	public function addCustomer($data) {
		$customer_id = parent::addCustomer($data);
		
		if (empty($customer_id))
			return;
			
		if (!empty($data['register_vendor'])) {
			
			$kamodel_vendor = $this->load->kamodel('extension/ka_extensions/ka_multivendor/vendor');
			$data['customer_id'] = $customer_id;
			$kamodel_vendor->addVendor($data);
		}
		
		return $customer_id;
	}
	

	public function editCustomer($customer_id, $data) {

		parent::editCustomer($customer_id, $data);

		if (empty($data['register_vendor']) && empty($data['update_vendor'])) {
			return;
		}

		// insert a vendor profile
		//
		$kamodel_vendor = $this->load->kamodel('extension/ka_extensions/ka_multivendor/vendor');
		$vendor = $kamodel_vendor->getVendor($customer_id);
		
		if (empty($vendor)) {
			$data['customer_id'] = $customer_id;
			$kamodel_vendor->addVendor($data);
		} else {
			$kamodel_vendor->editVendor($customer_id, $data);
		}
		
		// approve the vendor if required
		//
		if (!empty($data['vendor_status'])) {
			if ($kamodel_vendor->isAwaitingApproval($customer_id)) {
				$this->load->model('customer/customer_approval');

				$this->model_customer_customer_approval->approveVendor($customer_id);
			}
		}
		
		// disable all vendor's products when the profile is disabled
		//
		if (empty($data['vendor_status'])) {
			$this->db->query("UPDATE " . DB_PREFIX . "product SET
				status = 0
				WHERE vendor_id = '" . (int)$customer_id . "'
			");
		}
		
	}
	
	
	public function deleteCustomer($customer_id) {
	
		$model_vendor = $this->load->kamodel('extension/ka_extensions/ka_multivendor/vendor');
		
		if (!empty($model_vendor)) {
			$model_vendor->deleteVendor($customer_id);
		}
		
		return parent::deleteCustomer($customer_id);
	}
	
}	