<?php

namespace extension\ka_extensions\ka_multivendor;

class ModelCustomerCustomerApproval extends \ModelCustomerCustomerApproval {

	public function approveVendor($customer_id) {
		$this->db->query("UPDATE `" . DB_PREFIX . "ka_vendor` SET vendor_status = 1 WHERE customer_id = '" . (int)$customer_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "customer_approval` WHERE customer_id = '" . (int)$customer_id . "' AND `type` = 'vendor'");

		// send an email
		//
		$this->load->model('customer/customer');
		$customer = $this->model_customer_customer->getCustomer($customer_id);
		if (empty($customer)) {
			return;
		}
		
		$mail = new \KaMail($customer['language_id'], $customer['store_id']);
		$mail->data['customer'] = $customer;
		$mail->sendContent($customer['email'], $this->language->get('Vendor Account Approved'), 
			'extension/ka_extensions/ka_multivendor/mail/account_approved'
		);
		
		// add a record to the customer history
		//
		$comment = 'The vendor profile was approved by admin (id:' . $this->user->getId() . ')';
		$this->model_customer_customer->addHistory($customer_id, $comment);		
	}

	
	public function denyVendor($customer_id) {
		$this->db->query("UPDATE `" . DB_PREFIX . "ka_vendor` SET vendor_status = 0 WHERE customer_id = '" . (int)$customer_id . "'");
		$this->db->query("DELETE FROM `" . DB_PREFIX . "customer_approval` WHERE customer_id = '" . (int)$customer_id . "' AND `type` = 'vendor'");
		
		// send an email
		//
		$this->load->model('customer/customer');
		$customer = $this->model_customer_customer->getCustomer($customer_id);
		if (empty($customer)) {
			return;
		}
		
		$mail = new \KaMail($customer['language_id'], $customer['store_id']);
		$mail->data['customer'] = $customer;
		$mail->sendContent($customer['email'], $this->language->get('Vendor Account Declined'), 
			'extension/ka_extensions/ka_multivendor/mail/account_declined'
		);
		
		// add a record to the customer history
		//
		$comment = 'The vendor profile was declined by admin (id:' . $this->user->getId() . ')';
		$this->model_customer_customer->addHistory($customer_id, $comment);
	}
}