<?php
/*
	$Project$
	$Author$

	$Version$ ($Revision$)
*/

namespace extension\ka_extensions\ka_multivendor;

class ControllerAccountAccount extends \ControllerAccountAccount {

	use \extension\ka_extensions\TraitController;

	public function index() {

		$this->load->language('extension/ka_extensions/ka_multivendor/profile');
	
		$this->load->disableRender();
		parent::index();
		$this->load->enableRender();

		$data = $this->getRenderData();
		$template = $this->getRenderTemplate();

		$kamodel_vendor = $this->load->kamodel('extension/ka_extensions/ka_multivendor/vendor');
		$vendor_status = $kamodel_vendor->getVendorStatus();
		
		if (is_null($vendor_status)) {
			$data['vendor_register'] = $this->url->link('extension/ka_extensions/ka_multivendor/profile/register', '', true);
		} else {
			if (!empty($vendor_status)) {
				$data['vendor_status'] = true;
				$data['products_link'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', '', true);
				if (\KaGlobal::isKaInstalled('ka_smethods')) {
					if ($this->config->get('ka_multivendor_shipping_setup') == 'custom') {
						$data['shipping_link'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/shippings', '', true);
					}
				}
				$data['sales_link']    = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/orders', '', true);					
				$data['vendor_edit'] = $this->url->link('extension/ka_extensions/ka_multivendor/profile/edit', '', true);
			} else {
				if ($kamodel_vendor->isAwaitingApproval()) {
					$data['is_awaiting_approval'] = true;
				}
			}
		}
		
		$data['is_ka_multivendor_installed'] = true;
		
		$this->response->setOutput($this->load->view('account/account', $data));
	}
}
