<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 92 $)
*/

namespace extension\ka_extensions\ka_multivendor;

class ControllerApiCart extends \ControllerApiCart {

	protected function getProductsByVendor($products) {
	
		$kamodel_vendor = $this->load->kamodel('extension/ka_extensions/ka_multivendor/vendor');
	
		$vendors = array();
		if (empty($products)) {
			return $vendors;
		}
		
		// get products by vendors
		//
		foreach ($products as $p) {
		
			$vendor_id = $p['vendor_id'];
		
			if (empty($vendors[$vendor_id])) {
				$vendors[$vendor_id] = array(
					'vendor_id' => $vendor_id,
					'products'  => array(),
					'subtotal'  => null
				);
			}
			
			$total = $p['quantity'] * $p['unit_price'];
			$vendors[$vendor_id]['subtotal'] += $total;
			
			$vendors[$vendor_id]['products'][] = $p;
		}

		
		// update information by vendors
		//
		foreach ($vendors as $vendor_id => &$v) {
			// Display prices
			if (!is_null($v['subtotal'])) {
				$v['subtotal'] = $this->currency->format($v['subtotal'], $this->session->data['currency']);
			}
			
			$v['info'] = $kamodel_vendor->getVendor($vendor_id);

			if (!empty($this->session->data['shipping_methods_by_vendor'])) {
				$v['shipping_methods'] = $this->session->data['shipping_methods_by_vendor'][$vendor_id];
			} else {
				$v['shipping_methods'] = array();
			}
			
			if (!empty($this->session->data['shipping_method_by_vendor'][$vendor_id])) {
				$v['selected_method'] = $this->session->data['shipping_method_by_vendor'][$vendor_id]['code'];
			}
		}

		return $vendors;
	}	
}