<?php
/*
	$Project$
	$Author$

	$Version$ ($Revision$)
*/

namespace extension\ka_extensions\ka_multivendor;

class ControllerApiOrder extends \ControllerApiOrder {

	/*
		Ajax call to update the vendor order status	
		
		Parameters:
			- vendor_order_id (required)
			- delivery_status_id (required)
			- comments (optional)
			- notify_customer (optional)
			
		
	*/
	public function changeVendorStatus() {

		// standard Opencart API permission check
		//
		$this->load->language('api/order');

		$json = array();

		if (!isset($this->session->data['api_id'])) {
			$json['error'] = $this->language->get('error_permission');
			$this->response->addHeader('Content-Type: application/json');
			$this->response->setOutput(json_encode($json));
		}

		$kamodel_order = $this->load->kamodel('extension/ka_extensions/ka_multivendor/order');
		
		$params = array(
			'vendor_order_id'    => 0, 
			'delivery_status_id' => 0, 
			'comments'           => '', 
			'notify_customer'    => false,
		);
		$params = array_replace($params, $this->request->post);
		
		if (empty($params['vendor_order_id']) || empty($params['delivery_status_id'])) {
			$json['error'] = $this->language->get('Invalid Parameters');
			$this->response->addHeader('Content-Type: application/json');
			$this->response->setOutput(json_encode($json));
			return;
		}

		try {
			$kamodel_order->changeVendorStatus($params['vendor_order_id'], $params['delivery_status_id'], $params['comments'], $params['notify_customer'], true);
			$json['success'] = $this->language->get('The status updated successfully');
		} catch (\Exception $e) {
			$json['error'] = $e->getMessage();
		}

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
}