<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 151 $)
*/

namespace extension\ka_extensions\ka_multivendor;

class ControllerCheckoutConfirm extends \ControllerCheckoutConfirm {

	use \extension\ka_extensions\TraitController;

	public function index() {

		if (!$this->cart->isMultivendorCart()) {
			return parent::index();
		}

		if (!$this->validateMulitvendor()) {
			$data['redirect'] = $this->url->link('checkout/checkout', '', true);
			$this->response->setOutput($this->load->view('checkout/confirm', $data));			
		}
		
		$this->cart->unsetVendorFilter();
		
		$this->disableRender();
		parent::index();
		$this->enableRender();
		
		$template = $this->getRenderTemplate();
		$data     = $this->getRenderData();
		
		$this->response->setOutput($this->load->view($template, $data));
	}
	
	
	protected function validateMulitvendor() {

		$kamodel_vendor = $this->load->kamodel('extension/ka_extensions/ka_multivendor/vendor');
		
		$errors = array();
		$vendors = $this->cart->getVendors();
	
		foreach ($vendors as $vendor_id => $v) {
			
			$vendor_info = $kamodel_vendor->getVendor($vendor_id);
				
			$this->cart->setVendorFilter($vendor_id);
			if ($this->cart->hasShipping()) {
				if (empty($this->session->data['shipping_method_by_vendor'][$vendor_id])) {
					$errors[] = sprintf($this->language->get("Shipping method is not selected for '%s'"), $vendor_info['name']);
				}
			}
		}

		if (!empty($errors)) {
			$this->session->data['error_warning'] = implode("<br>", $errors);
			return false;
		}
		
		return true;
	}	
}
