<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 154 $)
	
*/

namespace extension\ka_extensions\ka_multivendor;

class ControllerVendorCategory extends \extension\ka_extensions\Controller { 

	protected $errors = array();
	protected $post = array();

	protected $kamodel_vendor_category;
	
	function onload() {
		// load langauge files
		$this->load->language('extension/ka_extensions/ka_multivendor/common');
		$this->kamodel_vendor_category = $this->load->kamodel('extension/ka_extensions/ka_multivendor/vendor/category');
	}
	
	public function autocomplete() {
		$json = array();

		if (isset($this->request->get['filter_name'])) {

			$filter_data = array(
				'filter_name' => $this->request->get['filter_name'],
				'start'       => 0,
				'limit'       => 5
			);

			$results = $this->kamodel_vendor_category->getCategories($filter_data);

			foreach ($results as $result) {
				$json[] = array(
					'category_id' => $result['category_id'],
					'name'        => strip_tags(html_entity_decode($result['name'], ENT_QUOTES, 'UTF-8'))
				);
			}
		}

		$sort_order = array();

		foreach ($json as $key => $value) {
			$sort_order[$key] = $value['name'];
		}

		array_multisort($sort_order, SORT_ASC, $json);

		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
	
	
	/*
		ajax call from the product edit page.
	*/
	public function attributes() {

		$this->load->model('localisation/language');
		$languages = $this->model_localisation_language->getLanguages();
	
		$params = array(
			'category_id' => 0,
		);
		$json = array();
		
		$params = array_merge($params, $this->request->get);

		$html = array();
		
		if (empty($params['category_id'])) {
		
			foreach ($languages as $l) {
				$data['language_id'] = $l['language_id'];
				$html[$l['language_id']] = '';
			}
		
			$json['html'] = $html;
			
			$this->response->addHeader('Content-Type: application/json');
			$this->response->setOutput(json_encode($json));
			return;
		}
		
		// get attributes
		//
		$fields = $this->kamodel_vendor_category->getCategoryAttributeFields(array('category_id' => $params['category_id']));
		$data = array(
			'fields' => $fields
		);
		
		foreach ($languages as $l) {
			$data['language_id'] = $l['language_id'];
			
			$html[$l['language_id']] = trim($this->load->view('extension/ka_extensions/ka_multivendor/vendor/product/attributes', $data));
		}

		$json['html'] = $html;
		
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
	
}

class_alias(__NAMESPACE__ . '\ControllerVendorCategory', '\ControllerExtensionKaExtensionsKaMultivendorVendorCategory');