<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 151 $)
	
*/

namespace extension\ka_extensions\ka_multivendor;

class ControllerVendorProducts extends \extension\ka_extensions\Controller { 

	protected $errors = array();
	protected $post = array();

	protected $kamodel_vendor_product;
	
	function onload() {
		// load langauge files
		$this->load->language('account/account');
		$this->load->language('extension/ka_extensions/ka_multivendor/common');
		$this->load->language('extension/ka_extensions/ka_multivendor/vendor/product');

		$this->post = $this->request->get;
		$this->post = array_merge($this->post, $this->request->post);
		
		// load a model file
		$this->kamodel_vendor_product = $this->load->kamodel('extension/ka_extensions/ka_multivendor/vendor/product');
		$this->load->model('tool/image');
		
		// check vendor access
		//
		if (!$this->customer->isVendor()) {
			$this->response->redirect($this->url->link('account/account', '', true));
		}
	}

	
  	public function index() {
    	$this->getList();
  	}

  	  	
  	public function enable_selected() {

		$url = '';
		if (!empty($this->session->data['product_url'])) {
			$url = '&' . $this->session->data['product_url'];
		}
		
    	if (isset($this->post['selected'])) {
			foreach ($this->post['selected'] as $product_id) {
				$this->kamodel_vendor_product->enableProduct($product_id);
			}
		}
			
		$this->addTopMessage($this->language->get('txt_saved_successfully'));
		$this->response->redirect($this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', $url, true));
  	}

  	
  	public function disable_selected() {

		$url = '';
		if (!empty($this->session->data['product_url'])) {
			$url = '&' . $this->session->data['product_url'];
		}
		
    	if (isset($this->post['selected'])) {
			foreach ($this->post['selected'] as $product_id) {
				$this->kamodel_vendor_product->disableProduct($product_id);
			}
		}
			
		$this->addTopMessage($this->language->get('txt_saved_successfully'));
		$this->response->redirect($this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', $url, true));
  	}
  	
  	
  	public function delete() {

		$url = '';
		if (!empty($this->session->data['product_url'])) {
			$url = '&' . $this->session->data['product_url'];
		}
		
    	if (isset($this->post['selected'])) {
			foreach ($this->post['selected'] as $product_id) {
				$this->kamodel_vendor_product->deleteProduct($product_id);
			}
		}
			
		$this->addTopMessage($this->language->get('txt_saved_successfully'));
		$this->response->redirect($this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', $url, true));
  	}


  	public function copy() {
  	
		$url = '';
		if (!empty($this->session->data['product_url'])) {
			$url = '&' . $this->session->data['product_url'];
		}

		$error = '';
		if (!empty($this->request->post['selected'])) {
			foreach ($this->request->post['selected'] as $src_product_id) {
				$product_id = $this->kamodel_vendor_product->copyProduct($src_product_id);
				if (empty($product_id)) {
					$error = $this->kamodel_vendor_product->getLastError();
					break;
				}
			}
		}
		
		if (empty($error)) {
			$this->addTopMessage($this->language->get('txt_saved_successfully'));
			$this->response->redirect($this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', $url, true));
		} else {
			$this->addTopMessage($this->language->get('text_operation_failed') . ': ' . $error, 'E');
			$this->response->redirect($this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', $url, true));
		}
  	}

  	protected function getList() {

  		$this->document->setTitle($this->language->get('text_list_page_title'));
  	
  		$params = array(
			'sort'  => 'product_id',
  			'order' => 'DESC', 
  			'page'  => '1',
			'filter_text'     => null,
			'filter_quantity' => null,
			'filter_image'    => null,
			'filter_manufacturer_id' => null,
			'filter_price'    => null,
			'filter_status'   => null,
  		);
  		
		$url_params = new \KaUrlParams($this->request, $params);
		
		$this->session->data['product_url'] = $url_params->getUrl();
		
		$this->data['sort_product_id'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', '&' . $url_params->getUrlSort('p.product_id'), true);
		$this->data['sort_name'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', '&' . $url_params->getUrlSort('pd.name'), true);
		$this->data['sort_model'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', '&' . $url_params->getUrlSort('p.model'), true);
		$this->data['sort_quantity'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', '&' . $url_params->getUrlSort('p.quantity'), true);
		$this->data['sort_price'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', '&' . $url_params->getUrlSort('p.price'), true);
		$this->data['sort_status'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/products', '&' . $url_params->getUrlSort('p.status'), true);

  		$this->data['breadcrumbs'] = array();
  		
		$this->data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$this->data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_account'),
			'href' => $this->url->link('account/account', '', true)
		);

   		$this->data['breadcrumbs'][] = array(
       		'text' => $this->language->get('text_list_page_title'),
   		);
		
		$url = $url_params->getUrl();
		if (!empty($url)) {
			$url = '&' . $url;
		}
		
		$this->data['insert'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/product', $url, true);
		$this->data['copy'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/products/copy', $url, true);
		$this->data['delete'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/products/delete', $url, true);
		
		$this->data['act_enable_selected'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/products/enable_selected', $url, true);
		$this->data['act_disable_selected'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/products/disable_selected', $url, true);

		$this->data['products'] = array();

		$filter_data = $url_params->getParams();
		$filter_data['start'] = ($filter_data['page'] - 1) * $this->config->get('config_limit_admin');
		$filter_data['limit'] = $this->config->get('config_limit_admin');

		$vendor = $this->kamodel_vendor->getVendor();
		$this->data['vendor_product_limit'] = $vendor['product_limit'];
		
		$products_total = $this->kamodel_vendor_product->getProductsTotal($filter_data);
		
		$results = $this->kamodel_vendor_product->getProducts($filter_data);
 
       	foreach ($results as $result) {
       	
    		$pd = $this->kamodel_vendor_product->getProductDescription($result['product_id']);
    		$result['display_price'] = $this->currency->format($result['price'], $this->session->data['currency']);
    		if (!empty($result['special'])) {
	    		$result['display_special'] = $this->currency->format($result['special'], $this->session->data['currency']);
	    	}
    		
    		$result['name'] = !empty($pd[$this->config->get('config_language_id')]['name']) ? $pd[$this->config->get('config_language_id')]['name'] : '';
    	
			// image
			if (is_file(DIR_IMAGE . $result['image'])) {
				$result['full_image'] = $this->config->get('config_url') . 'image/' . $result['image'];
				$result['image'] = $this->model_tool_image->resize($result['image'], 80, 80);
			} else {
				$result['image'] = $this->model_tool_image->resize('no_image.png', 80, 80);
			}
			
			$actions = array();
			
			$actions[] = array(
				'text' => $this->language->get('text_edit'),
				'href' => $this->url->link('extension/ka_extensions/ka_multivendor/vendor/product', '&product_id=' . $result['product_id'] . $url, true),
				'icon' => 'fa-pencil',
			);

			$actions[] = array(
				'text' => $this->language->get('View'),
				'href' => $this->url->link('product/product', '&product_id=' . $result['product_id'] . '&preview=1' . $url, true),
				'icon' => 'fa-eye',
			);
			
			$result['actions'] = $actions;
			
			$this->data['products'][] = $result;
		}

		$this->data['text_no_results']  = $this->language->get('text_no_results');
		$pagination = new \KaPagination();
		$pagination->total = $products_total;
		$pagination->page  = $url_params->getParam('page');
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->text  = $this->language->get('text_pagination');

		$url = '&' . $url_params->getUrl(['page' => null]);
		$pagination->url = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/product', $url . '&page={page}', true);

		$this->data['pagination'] = $pagination->render();
		$this->data['results'] = $pagination->getResults();
		
		$this->data['params'] = $url_params->getParams();
		
		$this->showPage('extension/ka_extensions/ka_multivendor/vendor/product_list');
  	}
}

class_alias(__NAMESPACE__ . '\ControllerVendorProducts', '\ControllerExtensionKaExtensionsKaMultivendorVendorProducts');