<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 139 $)
	
*/

namespace extension\ka_extensions\ka_multivendor;

class ControllerVendorShippings extends \extension\ka_extensions\Controller { 

	protected $errors = array();
	protected $post = array();

	protected $kamodel_shipping;
	
	function onload() {
		// load langauge files
		$this->load->language('account/account');
		$this->load->language('extension/ka_extensions/ka_multivendor/common');
		$this->load->language('extension/ka_extensions/ka_multivendor/vendor/shipping');

		$this->kamodel_shipping = $this->load->kamodel('extension/ka_extensions/ka_multivendor/shipping');
		
		// check vendor access
		//
		if (!$this->customer->isVendor()) {
			$this->response->redirect($this->url->link('account/account', '', true));
		}
		
		if ($this->config->get('ka_multivendor_shipping_setup') != 'custom') {
			$this->response->redirect($this->url->link('account/account', '', true));
		}
	}

	
  	public function index() {
    	$this->getList();
  	}

  	
  	public function delete() {

		$url = '';
		if (!empty($this->session->data['shippings_url'])) {
			$url = '&' . $this->session->data['shippings_url'];
		}
		
    	if (isset($this->request->post['selected'])) {
			foreach ($this->request->post['selected'] as $shipping_method_id) {
				$this->kamodel_shipping->deleteshipping($shipping_method_id);
			}
		}
			
		$this->addTopMessage($this->language->get('txt_saved_successfully'));
		$this->response->redirect($this->url->link('extension/ka_extensions/ka_multivendor/vendor/shippings', $url, true));
  	}


  	protected function getList() {

  		$this->document->setTitle($this->language->get('text_shipping_list_page_title'));
  	
  		$params = array(
  			'page' => 1,
  		);
  		
		$url_params = new \KaUrlParams($this->request, $params);
		
		$this->session->data['shippings_url'] = $url_params->getUrl();
		
  		$this->data['breadcrumbs'] = array();
  		
		$this->data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$this->data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_account'),
			'href' => $this->url->link('account/account', '', true)
		);

   		$this->data['breadcrumbs'][] = array(
       		'text' => $this->language->get('text_shipping_list_page_title'),
   		);
		
		$url = $url_params->getUrl();
		if (!empty($url)) {
			$url = '&' . $url;
		}
		
		$this->data['add'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/shipping', $url, true);
		$this->data['delete'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/shippings/delete', $url, true);
		
		$this->data['act_enable_selected']  = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/shippings/enable_selected', $url, true);
		$this->data['act_disable_selected'] = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/shippings/disable_selected', $url, true);

		$this->data['shippings'] = array();

		$shippings_total = $this->kamodel_shipping->getShippingsTotal();
		
		$results = $this->kamodel_shipping->getShippings();

    	foreach ($results as $result) {

			$actions = array();
			
			$actions[] = array(
				'text' => $this->language->get('text_edit'),
				'href' => $this->url->link('extension/ka_extensions/ka_multivendor/vendor/shipping', '&shipping_method_id=' . $result['shipping_method_id'] . $url, true),
				'icon' => 'fa-pencil',
			);

			$result['actions'] = $actions;
			
			$this->data['shippings'][] = $result;
		}

		$this->data['text_no_results']  = $this->language->get('text_no_results');
		$pagination = new \KaPagination();
		$pagination->total = $shippings_total;
		$pagination->page  = $url_params->getParam('page');
		$pagination->limit = $this->config->get('config_limit_admin');
		$pagination->text  = $this->language->get('text_pagination');

		$url = '&' . $url_params->getUrl(['page' => null]);
		$pagination->url = $this->url->link('extension/ka_extensions/ka_multivendor/vendor/shipping', $url . '&page={page}', true);

		$this->data['pagination'] = $pagination->render();
		$this->data['results'] = $pagination->getResults();
		
		$this->data['params'] = $url_params->getParams();
		
		$this->showPage('extension/ka_extensions/ka_multivendor/vendor/shipping_list');
  	}
  	
  	
  	public function enable_selected() {

		$url = '';
		if (!empty($this->session->data['product_url'])) {
			$url = '&' . $this->session->data['product_url'];
		}
		
    	if (isset($this->request->post['selected'])) {
			foreach ($this->request->post['selected'] as $id) {
				$this->kamodel_shipping->enableShipping($id);
			}
		}
			
		$this->addTopMessage($this->language->get('txt_saved_successfully'));
		$this->response->redirect($this->url->link('extension/ka_extensions/ka_multivendor/vendor/shippings', $url, true));
  	}

  	
  	public function disable_selected() {

		$url = '';
		if (!empty($this->session->data['shipping_url'])) {
			$url = '&' . $this->session->data['shipping_url'];
		}
		
    	if (isset($this->request->post['selected'])) {
			foreach ($this->request->post['selected'] as $id) {
				$this->kamodel_shipping->disableShipping($id);
			}
		}
			
		$this->addTopMessage($this->language->get('txt_saved_successfully'));
		$this->response->redirect($this->url->link('extension/ka_extensions/ka_multivendor/vendor/shippings', $url, true));
  	}
}

class_alias(__NAMESPACE__ . '\ControllerVendorShippings', '\ControllerExtensionKaExtensionsKaMultivendorVendorShippings');