<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 137 $)
*/

namespace extension\ka_extensions\ka_multivendor;

class ControllerVendors extends \extension\ka_extensions\Controller {

	protected function onLoad() {
	
		$this->load->language('extension/ka_extensions/ka_multivendor/vendor');

		$this->load->model('catalog/product');
		$this->load->model('tool/image');
	}

	public function index() {
	
		$this->document->setTitle($this->language->get('heading_title'));

		$data['breadcrumbs'] = array();
		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_brand'),
			'href' => $this->url->link('product/vendor')
		);

		$data['categories'] = array();

		$results = $this->kamodel_vendor->getVendors();

		foreach ($results as $result) {
			if (is_numeric(utf8_substr($result['name'], 0, 1))) {
				$key = '0 - 9';
			} else {
				$key = utf8_substr(utf8_strtoupper($result['name']), 0, 1);
			}

			if (!isset($data['categories'][$key])) {
				$data['categories'][$key]['name'] = $key;
			}

			$data['categories'][$key]['vendors'][] = array(
				'name' => $result['name'],
				'href' => $this->url->link('extension/ka_extensions/ka_multivendor/vendor', 'vendor_id=' . $result['vendor_id'])
			);
		}

		$data['request_uri'] = $this->request->server['REQUEST_URI'];
		$data['continue'] = $this->url->link('common/home');

		$this->showPage('extension/ka_extensions/ka_multivendor/vendors', $data);
	}
}

class_alias(__NAMESPACE__ . '\ControllerVendors', 'ControllerExtensionKaExtensionsKaMultivendorVendors');