<?php

namespace extension\ka_extensions\ka_multivendor;

class ModelCatalogProduct extends \ModelCatalogProduct {

	use \extension\ka_extensions\TraitDBFilter;

	public function getVendorProduct_DbFilter($sql) {
		$sql = str_replace(
			array(
				"AND p.date_available <= NOW()",
				"AND p.status = '1'",
			),
			'',
			$sql
		);
	
		return $sql;
	}
	
	/*
		It is called for showing a product preview for the vendor
	*/
	public function getVendorProduct($product_id) {

		$this->db->setFilter((array($this, "getVendorProduct_DbFilter")));
		$product = $this->getProduct($product_id);
		$this->db->removeFilter();
		
		if (empty($product)) {
			return null;
		}
		
		return $product;
	}
	
	
	public function getProductVendor($product_id) {
	
		$vendor = array();

		$product = $this->db->query("SELECT vendor_id FROM " . DB_PREFIX . "product
			WHERE product_id = '" . (int)$product_id . "'
		")->row;
		
		if (empty($product)) {
			return $vendor;
		}
	
		$kamodel_vendor = $this->load->kamodel('extension/ka_extensions/ka_multivendor/vendor');
		$vendor = $kamodel_vendor->getVendor($product['vendor_id']);
		
		return $vendor;
	}

}