<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 150 $)
*/

namespace extension\ka_extensions\ka_multivendor;

class ModelSettingExtension extends \ModelSettingExtension {


	/*
		Return shipping extensions of the active vendor only
	*/
	function getExtensions($type) {

		$extension = parent::getExtensions($type);
		
		if ($type != 'shipping') {
			return $extension;
		}
		
		if (empty($extension)) {
			return $extension;
		}

		$current_vendor_id = $this->cart->getVendorId();
		if (is_null($current_vendor_id)) {
			return $extension;
		}

		$kamodel_shipping = $this->load->kamodel('extension/ka_extensions/ka_multivendor/shipping');
		
		$shipping_setup = $this->config->get('ka_multivendor_shipping_setup');
		
		$_extensions = array();
		foreach ($extension as $ext) {
		
			$vid = $kamodel_shipping->getShippingVendor($ext['code']);

			if (is_null($vid)) {
				continue;
			}

			if ($shipping_setup == 'custom') {
				// rates are defined by the vendor
				if ($vid != $current_vendor_id) {
					continue;
				}
			}
			
			$_extensions[] = $ext;
		}
		
		return $_extensions;
	}
}