<?php

namespace extension\ka_extensions\ka_multivendor\table;
use extension\ka_extensions\atable as atable;

class Product extends ATable {

	const TABLE_NAME = 'product';

	function save($data, $allow_insert = true) {

		$product_id = null;
	
		if (!empty($data['product_id'])) {
			$kamodel_product = $this->load->kamodel('extension/ka_extensions/ka_multivendor/vendor/product');
			
			$product_id = $data['product_id'];
			if (!$kamodel_product->isVendorProduct($product_id)) {
				$product_id = null;
			}
			unset($data['product_id']);
			$data['vendor_id'] = $this->customer->getId();
		}

		$record = $this->getRecordFromData($data);
		if (empty($record)) {
			return null;
		}
		
		if (empty($product_id)) {
			$product_id = $this->insert($record);
		} else {
			$this->update($record, "product_id='" . $product_id . "'");
		}
		
		return $product_id;
	}
	
	
	function getRecordFromData($data) {
	
		// convert 'Unlimited' to native a 'Subtract' value
		if (isset($data['unlimited'])) {

			if (empty($data['unlimited'])) {
				$data['subtract'] = 1;
			} else {
				$data['subtract'] = 0;
			}
		}
		
		if (empty($data['minimum'])) {
			$data['minimum'] = 1;
		}
		
		return parent::getRecordFromData($data);
	}
	
	
	/*
		List of fields available for update by a vendor
	*/
	public function getFields() {
		
		$fields = array(
			'product_id'  => array(
				'primary_key' => true,
			),
			'vendor_id'   => array(),
			'price'       => array(),
			'model'       => array(),
			'mpn'         => array(),
			'quantity'    => array(),
			'price'       => array(),
			'subtract'    => array(),
			'minimum'     => array(),
			'status'      => array(),
			'manufacturer_id' => array(),
			'shipping'    => array(),
			'weight'      => array(),
			'weight_class_id' => array(),
			'length'      => array(),
			'width'       => array(),
			'height'      => array(),
			'length_class_id' => array(),
			'image'       => array(),
		);
		
		return $fields;
	}
}

class_alias(__NAMESPACE__ . '\Product', '\ModelExtensionKaExtensionsKaMultivendorTableProduct');