<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 138 $)
*/

namespace extension\ka_extensions\ka_multivendor;

class ModelVendorCategory extends \extension\ka_extensions\Model {

	private $kamodel_vendor_attributes;

	protected function onLoad() {
		$this->kamodel_vendor_attributes = $this->load->kamodel('extension/ka_extensions/ka_multivendor/vendor/attributes');
	}

	
	public function getCategory($category_id) {
		$category = $this->db->query("SELECT DISTINCT *, 
			(SELECT GROUP_CONCAT(cd1.name ORDER BY level SEPARATOR '&nbsp;&nbsp;&gt;&nbsp;&nbsp;') FROM " . DB_PREFIX . "category_path cp 
				LEFT JOIN " . DB_PREFIX . "category_description cd1 ON (cp.path_id = cd1.category_id AND cp.category_id != cp.path_id) 
				WHERE cp.category_id = c.category_id 
					AND cd1.language_id = '" . (int)$this->config->get('config_language_id') . "' 
				GROUP BY cp.category_id
			) AS path FROM " . DB_PREFIX . "category c 
				LEFT JOIN " . DB_PREFIX . "category_description cd2 ON (c.category_id = cd2.category_id) 
			WHERE c.category_id = '" . (int)$category_id . "' 
				AND cd2.language_id = '" . (int)$this->config->get('config_language_id') . "'
		")->row;
		
		return $category;
	}

	public function getCategories($data = array()) {
		$sql = "SELECT cp.category_id AS category_id, GROUP_CONCAT(cd1.name ORDER BY cp.level SEPARATOR '&nbsp;&nbsp;&gt;&nbsp;&nbsp;') AS name, c1.parent_id, c1.sort_order FROM " . DB_PREFIX . "category_path cp LEFT JOIN " . DB_PREFIX . "category c1 ON (cp.category_id = c1.category_id) LEFT JOIN " . DB_PREFIX . "category c2 ON (cp.path_id = c2.category_id) LEFT JOIN " . DB_PREFIX . "category_description cd1 ON (cp.path_id = cd1.category_id) LEFT JOIN " . DB_PREFIX . "category_description cd2 ON (cp.category_id = cd2.category_id) WHERE cd1.language_id = '" . (int)$this->config->get('config_language_id') . "' AND cd2.language_id = '" . (int)$this->config->get('config_language_id') . "'";

		if (!empty($data['filter_name'])) {
			$sql .= " AND cd2.name LIKE '%" . $this->db->escape($data['filter_name']) . "%'";
		}

		$sql .= " GROUP BY cp.category_id";

		$sort_data = array(
			'name',
			'sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			$sql .= " ORDER BY " . $data['sort'];
		} else {
			$sql .= " ORDER BY sort_order";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC";
		} else {
			$sql .= " ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$query = $this->db->query($sql);

		return $query->rows;
	}
	
	
	public function getCategoryAttributeFields($category_id) {

		$fields = array();
		
		$filter = array(
			'category_id' => $category_id
		);
		$attrs = $this->kamodel_vendor_attributes->getAttributes($category_id);
		
		
		$last_group_id = 0;
		foreach ($attrs as $attr) {
			$lf = array(
				'title' => $attr['name'],
				'code' => $attr['attribute_id'],
				'type' => 'text',
			);
			if ($last_group_id != $attr['attribute_group_id']) {
				$lf['section'] = $attr['attribute_group'];
				$last_group_id = $attr['attribute_group_id'];
			}
			$fields[$lf['code']] = $lf;
		}
		
		return $fields;
	}
}

class_alias(__NAMESPACE__ . '\ModelVendorCategory', '\ModelExtensionKaExtensionsKaMultivendorVendorCategory');