<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 152 $)
*/

namespace extension\ka_extensions\ka_multivendor;

use extension\ka_extensions\QB;

class ModelVendorOrder extends AModelOrder {

	public function getOrderFields() {
	
		$fields = array(
			'order_method_id' => array(
				'code' => 'order_method_id',
			),
			'status' => array(
				'code' => 'status',
				'options' => array(
					'0' => $this->language->get('txt_disabled'),
					'1' => $this->language->get('txt_enabled'),
				)
			),
		);
		
		return $fields;
	}

	protected function getOrdersQB($data = array()) {

 		$qb = parent::getOrdersQB($data);
 		$qb->where("ka_vo.vendor_id = '" . (int)$this->customer->getId() . "'");
 		$qb->where("o.order_status_id");
 		
		return $qb;
	}
	
	protected function getVendorOrderQB($vendor_order_id) {
		
		$qb = parent::getVendorOrderQB($vendor_order_id);

		$qb->where("vendor_id = '" . $this->customer->getId() . "'");
		
		return $qb;
	}	
}

class_alias(__NAMESPACE__ . '\ModelVendorOrder', '\ModelExtensionKaExtensionsKaMultivendorVendorOrder');