function Form_reset(id) {

	$('#' + id + ' input, #' + id + ' select').val('');
	location = $('#' + id).attr('action');
}

$(document).ready(function() {
	// Image Loader
	$(document).on('click', 'a[data-toggle=\'image\']', function(e) {
		var $element = $(this);
		var $popover = $element.data('bs.popover'); // does the element have bs popover?

		e.preventDefault();

		// destroy all image popovers
		$('a[data-toggle="image"]').popover('destroy');

		// remove flickering (do not re-add popover when clicking for removal)
		if ($popover) {
			return;
		}

		$element.popover({
			html: true,
			placement: 'right',
			trigger: 'manual',
			content: function() {
				return '<button type="button" id="button-image" class="btn btn-primary"><i class="fa fa-pencil"></i></button> <button type="button" id="button-clear" class="btn btn-danger"><i class="fa fa-trash-o"></i></button>';
			}
		});

		$element.popover('show');

		$('#form-upload').remove();

		$('body').prepend('<form enctype="multipart/form-data" id="form-upload" style="display: none;"><input type="file" name="file[]" value="" multiple="multiple" /></form>');

		$('#form-upload input[name=\'file[]\']').trigger('click');

		if (typeof timer != 'undefined') {
	    	clearInterval(timer);
		}

		timer = setInterval(function() {
			if ($('#form-upload input[name=\'file[]\']').val() != '') {
				clearInterval(timer);

				$.ajax({
					url: 'index.php?route=extension/ka_extensions/ka_multivendor/vendor/filemanager/upload',
					type: 'post',
					dataType: 'json',
					data: new FormData($('#form-upload')[0]),
					cache: false,
					contentType: false,
					processData: false,
					beforeSend: function() {
						$('#button-upload i').replaceWith('<i class="fa fa-circle-o-notch fa-spin"></i>');
						$('#button-upload').prop('disabled', true);
					},
					complete: function() {
						$('#button-upload i').replaceWith('<i class="fa fa-upload"></i>');
						$('#button-upload').prop('disabled', false);
					},
					success: function(json) {
						if (json['error']) {
							alert(json['error']);
						}

						if (json['success']) {
							ka_extensions.showMessage(json['success']);
							$element.parent('.image-container').find('[data-id=add]').hide();
							$element.parent('.image-container').find('[data-id=delete]').show();
						}
						
						var value = $element.parent('.image-container').find('[data-id="image"]').val();
						
						// insert file name
						$element.parent('.image-container').find('[data-id="image"]').attr('value', json['image']);
						// insert thumbnail
						$element.parent('.image-container').find('img').attr('src', json['thumb']);
						
						// fire an event on setting the image
						var $e = $element.parent().trigger('image.set');
						
					},
					error: function(xhr, ajaxOptions, thrownError) {
						alert(thrownError + "\r\n" + xhr.statusText + "\r\n" + xhr.responseText);
					}
				});
			}
		}, 500);
		$element.popover('destroy');
	});
});