<?php
/*
	$Project: Multivendor $
	$Author: karapuz team <support@ka-station.com> $

	$Version: 1.0.0.0 $ ($Revision: 122 $)
*/

namespace extension\ka_extensions\ka_multivendor;

abstract class AModelOrderStatus extends \extension\ka_extensions\Model {

	public function getVendorOrderStatuses() {
	
		// get vendor statuses from the settings
		//
		$vendor_statuses = $this->config->get('ka_multivendor_vendor_statuses');
		if (empty($vendor_statuses) || !is_array($vendor_statuses)) {
			$vendor_statuses = array();
		}
	
		// get full information about vendor order statuses
		//
		$order_status_data = $this->cache->get('vendor_order_status.' . (int)$this->config->get('config_language_id'));

		if (!$order_status_data) {
			$query = $this->db->query("SELECT order_status_id, name FROM " . DB_PREFIX . "order_status 
				WHERE language_id = '" . (int)$this->config->get('config_language_id') . "' 
				AND order_status_id IN ('" . implode("','", $vendor_statuses) . "')
				ORDER BY name
			");

			$order_status_data = $query->rows;

			$this->cache->set('vendor_order_status.' . (int)$this->config->get('config_language_id'), $order_status_data);
		}
		
		return $order_status_data;
	}	
	
	
	public function isVendorStatus($order_status_id) {
	
		$statuses = $this->config->get('ka_multivendor_vendor_statuses');
		if (empty($statuses) || !is_array($statuses)) {
			return false;
		}
		
		if (in_array($order_status_id, $statuses)) {
			return true;
		}
		
		return false;
	}

	
	public function getOrderStatus($status_id, $language_id = 0) {
	
		if (empty($language_id)) {
			$language_id = $this->config->get('config_language_id');
		}
	
		$status = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_status 
			WHERE order_status_id = '" . (int)$status_id . "' 
			AND language_id = '" . (int)$language_id . "'
		")->row;
	
		return $status;
	}
	
}