<?php
/*
	$Project$
	$Author$

	$Version$ ($Revision$)
*/

namespace extension\ka_extensions\ka_multivendor;

use extension\ka_extensions\QB;

class AModelVendorOrderHistories extends \extension\ka_extensions\Model {

	protected function getOrderHistoriesQB($data) {
		
		$qb = new QB();

		$qb->select("oh.*, os.name AS status", "order_history", "oh");
		$qb->leftJoin("order_status", "os", "oh.order_status_id = os.order_status_id");
		$qb->where("oh.vendor_order_id", (int)$data['vendor_order_id']);
		$qb->where("os.language_id", (int)$this->config->get('config_language_id'));
		$qb->orderBy("oh.date_added DESC");
		
		$qb->limit((int)$data['start'], (int)$data['limit']);
		
		return $qb;
	}
	
	
	/*
		
	*/
	public function getOrderHistories($vendor_order_id, $start = 0, $limit = 10) {
	
		$history = array();
	
		$order = $this->kamodel_order->getVendorOrder($vendor_order_id);
		if (empty($order)) {
			return $history;
		}
	
		if ($start < 0) {
			$start = 0;
		}

		if ($limit < 1) {
			$limit = 10;
		}

		$data = array(
			'vendor_order_id' => $vendor_order_id,
			'start' => $start,
			'limit' => $limit,
		);		
		$history = $this->getOrderHistoriesQB($data)->query()->rows;

		return $history;
	}
	
	protected function getTotalOrderHistoriesQB($data) {
	
		$qb = new QB();
		
		$qb->select("COUNT(*) AS total", "order_history", "oh");
		$qb->where("oh.vendor_order_id", (int)$data['vendor_order_id']);
		
		return $qb;	
	}
	
	
	public function getTotalOrderHistories($vendor_order_id) {
	
		$data = array(
			'vendor_order_id' => $vendor_order_id,
		);
	
		$query = $this->getTotalOrderHistoriesQB($data)->query();

		return $query->row['total'];
	}	
}	
