<?php
/*
	$Project$
	$Author$

	$Version$ ($Revision$)
*/

namespace extension\ka_extensions\ka_multivendor;

class HTMLPurifier {

	static $allowed_tags = array(
		'br','p','pre','h2','h3','h4','b','u','span','ul','li','ol','a',
		'table', 'tbody', 'td', 'tr', 'thead', 'tfooter'
	);

	public function __construct() {
	
		if (!class_exists('\HTMLPurifier')) {
			require_once __DIR__ . '/htmlpurifier/HTMLPurifier.auto.php';
		}
	}

	public static function getInstance() {
		static $purifier;
		
		if (!empty($purifier)) {
			return $purifier;
		}
		
		$purifier = new static();
		
		return $purifier;
	}
	
	
	public static function purifyCustomerInput($text) {
	
		$wrapper = static::getInstance();
		
		$config = \HTMLPurifier_Config::createDefault();
		
		$allowed = implode(',', static::$allowed_tags);
		$config->set('HTML.Allowed', $allowed);
		
		$result = static::purify($text, $config);
		
		return $result;
	}
	
	
	protected static function purify($text, $config) {
		$purifier = new \HTMLPurifier($config);
		$text = $purifier->purify($text);		
		
		return $text;
	}
}