<?php

namespace extension\ka_extensions\ka_multivendor;

class Cart extends \Cart\Cart {
	protected $vendor_id = null;

	/*
		The function checks if the cart contains at least one product belonging to a vendor. If all products
		do not have vendors (for example, they are admin products). Then function returns false.
	*/
	public function isMultivendorCart() {
	
		$products = $this->getProducts();
		
		foreach ($products as $product) {
			if (!empty($product['vendor_id'])) {
				return true;
			}
		}

		return false;
	}

	public function getVendorId() {
		return $this->vendor_id;	
	}

	public function setVendorFilter($vendor_id) {
		$this->vendor_id = $vendor_id;
	}
	
	public function unsetVendorFilter() {
		$this->vendor_id = null;
	}
	
	public function getVendors() {
	
		$vendors = array();
		foreach ($this->getProducts() as $product) {
			$vendors[$product['vendor_id']] = array(
				'vendor_id' => $product['vendor_id'],
			);
		}

		return $vendors;
	}
	
	public function getProducts() {
	
		$products = parent::getProducts();
		if (!is_null($this->vendor_id)) {
			$_products = array();
			foreach ($products as $p) {
				if ($this->vendor_id == $p['vendor_id']) {
					$_products[] = $p;
				}
			}
			$products = $_products;
		}
		
		return $products;
	}
}