<?php
/*
	$Project$
	$Author$

	$Version$ ($Revision$)
*/

namespace extension\ka_extensions\ka_multivendor;

trait TraitAddressFormat {

	public function getCountryFormat($country_id) {
		
		$this->load->model('localisation/country');
		
		$country = $this->model_localisation_country->getCountry($country_id);
		if (!empty($country) && !empty($country['address_format'])) {
			return $country['address_format'];
		}
	
	
		// default address format
		$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
		
		return $format;
	}
	
	
	public function getFormattedAddress($data, $type, $format = '') {
	
		$address = '';
	
		if (empty($format)) {
			$format = $this->getCountryFormat($data[$type . '_country_id']);
		}

		if (empty($format)) {
			$format = '{firstname} {lastname}' . "\n" . '{company}' . "\n" . '{address_1}' . "\n" . '{address_2}' . "\n" . '{city} {postcode}' . "\n" . '{zone}' . "\n" . '{country}';
		}
		
		$find = array(
			'{firstname}',
			'{lastname}',
			'{company}',
			'{address_1}',
			'{address_2}',
			'{city}',
			'{postcode}',
			'{zone}',
			'{zone_code}',
			'{country}'
		);

		$replace = array(
			'firstname' => $data[$type . '_firstname'],
			'lastname'  => $data[$type . '_lastname'],
			'company'   => $data[$type . '_company'],
			'address_1' => $data[$type . '_address_1'],
			'address_2' => $data[$type . '_address_2'],
			'city'      => $data[$type . '_city'],
			'postcode'  => $data[$type . '_postcode'],
			'zone'      => $data[$type . '_zone'],
			'zone_code' => $data[$type . '_zone_code'],
			'country'   => $data[$type . '_country']
		);

		$address = str_replace(array("\r\n", "\r", "\n"), '<br />', preg_replace(array("/\s\s+/", "/\r\r+/", "/\n\n+/"), '<br />', trim(str_replace($find, $replace, $format))));
		
		return $address;
	}
}	
